#!/usr/bin/env node

var connect = require("connect");
var http = require("http");

var argv = require('optimist').boolean(['dummy', 'thrift', 'zeromq', 's']).usage('Usage: $0 [--thrift|--zeromq]').argv;

//argv.dummy = true;

module.exports = connect(
    connect.router(function(app) {

        var bridge;

        if(argv.thrift) {
            console.log("using thrift");
            var thrift = require("./thrift");
            bridge = new thrift.Client();
        } else if(argv.dummy) {
            console.log("using dummy");
            var dummy = require("./dummy");
            bridge = new dummy.Client();
        } else {
            console.log("using zeromq");
            var zmq = require("./zmq");
            bridge = new zmq.Client(print_stats=argv.s);
        }

        bridge.init();

        app.get('/stats', bridge.stats);

        app.get('/IndexService/indexLookup',  bridge.indexLookup);
        app.get('/IndexService/getBrowsingStatistics',  bridge.getBrowsingStatistics);
        app.get('/resultSet/getNumberOfElements', bridge.getNumberOfElements);
        app.get('/resultSet/getResult', bridge.getResult);

        app.get('/:context/services/IndexService/indexLookup',  bridge.indexLookup);
        app.get('/:context/services/IndexService/getBrowsingStatistics',  bridge.getBrowsingStatistics);
        app.get('/:context/services/resultSet/getNumberOfElements', bridge.getNumberOfElements);
        app.get('/:context/services/resultSet/getResult', bridge.getResult);

        app.get('/:context/mvc/directindex.do/IndexService/indexLookup',  bridge.indexLookup);
        app.get('/:context/mvc/directindex.do/IndexService/getBrowsingStatistics',  bridge.getBrowsingStatistics);
        app.get('/:context/mvc/directindex.do/resultSet/getNumberOfElements', bridge.getNumberOfElements);
        app.get('/:context/mvc/directindex.do/resultSet/getResult', bridge.getResult);

    })
); // .listen(3000);
