var thrift = require('mmikulicic-thrift'),
    IndexService = require('./gen-nodejs/IndexService'),
    ttypes = require('./gen-nodejs/index_types');

var os = require('os');

var common = require("./common");
var params = common.params;
var reply = common.reply;


function createClient() {
    var connection = thrift.createConnection("localhost", 9090);
    return thrift.createClient(IndexService, connection);

}

var clients = [];
var cpus = os.cpus().length;

for(var i=0; i<cpus; i++)
    clients.push(createClient());
var currentClient = 0;

function getClient() {
    return clients[currentClient++ % clients.length];
}


function ThriftClient() {}

ThriftClient.prototype = {
    init: function() {
    },
    
    indexLookup:  function(req, res, next) {
        var p = params(req);
        
        getClient().indexLookup(p.id, p.query, p.mdformat, p.layout, reply(res));
    },
    
    getBrowsingStatistics: function(req, res, next) {
        var p = params(req);
        
        getClient().getBrowsingStatistics(p.query, p.index, p.mdformat, p.layout, reply(res));
    },
    
    
    getNumberOfElements: function(req, res, next) {
        var p = params(req);
        
        getClient().getNumberOfElements(p.rsId, reply(res));
    },
    
    getResult: function(req, res, next) {
        var p = params(req);
        
        getClient().getResult(p.rsId, p.fromPosition, p.toPosition, reply(res));
    },
    
    stats: function(req, res, next) {
        res.end("not implemented for thrift client");
    }
}

exports.Client = ThriftClient